//BlueRP - Edict Management
#include <sourcemod>
#include <sdktools>
#include <morecolors>
#include <bluerp>

new g_iLaser;
new g_iHalo;

#pragma semicolon 1

#define CMDTAG 				"{cornflowerblue}[BlueRP]{default}" 
#define CONSOLETAG			"[BlueRP]"

//Plugin Information:
public Plugin:myinfo =
{
	name = "BlueRP - Edict Management",
	author = "_sidezz",
	description = "Edict and Prop management tools",
	version = "1.0",
	url = "sourcemod.net"
}

public OnMapStart()
{
	g_iLaser = PrecacheModel("materials/sprites/laserbeam.vmt", true);
	g_iHalo = PrecacheModel("materials/sprites/halo01.vmt", true);
}

public OnPluginStart()
{
	RegAdminCmd("sm_location", Command_getClientLocation, ADMFLAG_CUSTOM1, "[BlueRP] Returns your Coordinates");
	RegAdminCmd("sm_info", Command_edictInfo, ADMFLAG_CUSTOM1, "[BlueRP] Returns everything you can know of an Edict");   
	RegAdminCmd("sm_duplicate", Command_dupeEdict, ADMFLAG_CUSTOM1, "[BlueRP] Duplicate an Edict");
	RegAdminCmd("sm_create", Command_createEdict, ADMFLAG_CUSTOM1, "[BlueRP] Creates an Edict"); 
	RegAdminCmd("sm_throw", Command_throwEdict, ADMFLAG_CUSTOM1, "[BlueRP] Create and Throw an Edict"); 
	RegAdminCmd("sm_remove", Command_removeEdict, ADMFLAG_CUSTOM1, "[BlueRP] Removes an Edict");
	RegAdminCmd("sm_delete", Command_removeEdict, ADMFLAG_CUSTOM1, "[BlueRP] Removes an Edict");
	RegAdminCmd("sm_restart", Command_restartMap, ADMFLAG_CUSTOM1, "[BlueRP] Restart the map");
	RegAdminCmd("sm_entcreate", Command_entCreate, ADMFLAG_ROOT, "[BlueRP] Create an Entity");
}

public Action:Command_entCreate(Client, Args)
{
	new iEnt1 = CreateEntityByName("item_ammo_ar2_altfire"); 
	decl Float:fClientOrigin[3];
	if(IsValidEdict(iEnt1))
	{  	 
	    DispatchSpawn(iEnt1);

	    GetClientAbsOrigin(Client, fClientOrigin); 
	    TeleportEntity(iEnt1, fClientOrigin, NULL_VECTOR, NULL_VECTOR);
	    return Plugin_Handled;
	}
}

public Action:Command_restartMap(Client, Args)
{
	decl String:sMap[64];
	GetCurrentMap(sMap, sizeof(sMap));
	ForceChangeLevel(sMap, "Restart");
	return Plugin_Handled;
}

public Action:Command_getClientLocation(Client, iArgs)
{
	if(IsClientConnected(Client) && IsClientInGame(Client))
	{
		decl Float:fClientOrigin[3];
		GetClientAbsOrigin(Client, fClientOrigin); 
		CPrintToChat(Client, "%s Your Coordinates\n%s X:%f\n%s Y:%f\n%s Z:%f", CMDTAG, fClientOrigin[0], CMDTAG, fClientOrigin[1], CMDTAG, fClientOrigin[2]);         
		return Plugin_Handled;
	}
}

public Action:Command_edictInfo(Client, iArgs)
{
    decl String:sModelName[64];
    decl String:sClassName[64];
    new iEnt = GetClientAimTarget(Client, false);
    if(IsValidEdict(iEnt))
    {
	    GetEdictClassname(iEnt, sClassName, sizeof(sClassName));
	    GetEntPropString(iEnt, Prop_Data, "m_ModelName", sModelName, sizeof(sClassName));
	    CPrintToChat(Client, "%s Model:%s\n%s Classname:%s\n%s Edict Index:%i", CMDTAG, sModelName, CMDTAG, sClassName, CMDTAG, iEnt);         
	    return Plugin_Handled;
	}
}

public Action:Command_dupeEdict(Client, iArgs)
{
    decl String:sModelName[128];

    new iEnt = GetClientAimTarget(Client, false);
    if(IsValidEdict(iEnt))
    {
    	GetEntPropString(iEnt, Prop_Data, "m_ModelName", sModelName, sizeof(sModelName));
    	PrecacheModel(sModelName, true);
    }
    else return Plugin_Handled;
    
    new iEnt2 = CreateEntityByName("prop_physics_override");   	 
    DispatchKeyValue(iEnt2, "physdamagescale", "0.0");
    DispatchKeyValue(iEnt2, "model", sModelName);
    DispatchSpawn(iEnt2);
   
    decl Float:fFurnitureOrigin[3];  
    decl Float:fClientOrigin[3];
    decl Float:fEyeAngles[3];

    GetClientEyeAngles(Client, fEyeAngles);
    GetClientAbsOrigin(Client, fClientOrigin); 

    fFurnitureOrigin[0] = (fClientOrigin[0] + (50 * Cosine(DegToRad(fEyeAngles[1]))));
    fFurnitureOrigin[1] = (fClientOrigin[1] + (50 * Sine(DegToRad(fEyeAngles[1]))));
    fFurnitureOrigin[2] = (fClientOrigin[2] + 100);

    TeleportEntity(iEnt2, fFurnitureOrigin, NULL_VECTOR, NULL_VECTOR);
    SetEntityMoveType(iEnt2, MOVETYPE_VPHYSICS);    
    return Plugin_Handled;
}

public Action:Command_throwEdict(Client, iArgs)
{
	if(Client == 0)
	{
		PrintToConsole(Client, "%s You can't use this command in the Server Console", CONSOLETAG);
		return Plugin_Handled;
	}

	if(iArgs != 1)
	{
	    PrintToConsole(Client, "%s Invalid Syntax: sm_throw <model>", CONSOLETAG);
	    CPrintToChat(Client, "%s Invalid Syntax: sm_throw <model>", CMDTAG);
	    return Plugin_Handled;
	}

	decl String:sModelName[64];
	GetCmdArg(1, sModelName, sizeof(sModelName));

	new iEnt = CreateEntityByName("prop_physics_override"); 
	DispatchKeyValue(iEnt, "physdamagescale", "0.0");
	DispatchKeyValue(iEnt, "model", sModelName);
	DispatchSpawn(iEnt);

	decl Float:fFurnitureOrigin[3];  
	decl Float:fClientOrigin[3];
	decl Float:fEyeAngles[3];
	decl Float:fPush[3];

	GetClientEyeAngles(Client, fEyeAngles);
	GetClientAbsOrigin(Client, fClientOrigin); 

	fPush[0] = (5000.0 * Cosine(DegToRad(fEyeAngles[1])));
	fPush[1] = (5000.0 * Sine(DegToRad(fEyeAngles[1])));
	fPush[2] = (-12000.0 * Sine(DegToRad(fEyeAngles[0])));

	fFurnitureOrigin[0] = (fClientOrigin[0] + (50 * Cosine(DegToRad(fEyeAngles[1]))));
	fFurnitureOrigin[1] = (fClientOrigin[1] + (50 * Sine(DegToRad(fEyeAngles[1]))));
	fFurnitureOrigin[2] = (fClientOrigin[2]);

	new aBeam[4] = {255, 255, 0, 255}; 
	TE_SetupBeamFollow(iEnt, g_iLaser, g_iHalo, 1.0, 8.0, 8.0, 1000, aBeam);
	TE_SendToAll();

	CPrintToChat(Client,"%s Throw Edict: %f %f %f", CMDTAG, fPush[0], fPush[1], fPush[2]);            
	TeleportEntity(iEnt, fFurnitureOrigin, NULL_VECTOR, fPush);
	IgniteEntity(iEnt, 5.0);
	SetEntityMoveType(iEnt, MOVETYPE_VPHYSICS); 
	return Plugin_Handled;
}

public Action:Command_createEdict(Client, iArgs)
{
	if(Client == 0)
	{
		PrintToConsole(Client, "%s You can't use this command in the Server Console", CONSOLETAG);
		return Plugin_Handled;
	}

	if(iArgs != 1)
	{
	    PrintToConsole(Client, "%s Invalid Syntax: sm_create <model>", CONSOLETAG);
	    CPrintToChat(Client, "%s Invalid Syntax: sm_create <model>", CMDTAG);
	    return Plugin_Handled;
	}

	decl String:sModelName[64];
	GetCmdArg(1, sModelName, sizeof(sModelName));
	PrecacheModel(sModelName, true);

	new iEnt = CreateEntityByName("prop_physics_override");

	DispatchKeyValue(iEnt, "physdamagescale", "0.0");
	DispatchKeyValue(iEnt, "model", sModelName);
	DispatchSpawn(iEnt);

	decl Float:fFurnitureOrigin[3];  
	decl Float:fClientOrigin[3];
	decl Float:fEyeAngles[3];

	GetClientEyeAngles(Client, fEyeAngles);
	GetClientAbsOrigin(Client, fClientOrigin);

	fFurnitureOrigin[0] = (fClientOrigin[0] + (50 * Cosine(DegToRad(fEyeAngles[1]))));
	fFurnitureOrigin[1] = (fClientOrigin[1] + (50 * Sine(DegToRad(fEyeAngles[1]))));
	fFurnitureOrigin[2] = (fClientOrigin[2] + 100);
	             
	TeleportEntity(iEnt, fFurnitureOrigin, NULL_VECTOR, NULL_VECTOR);
	SetEntityMoveType(iEnt, MOVETYPE_VPHYSICS);   
	return Plugin_Handled;
}

public Action:Command_removeEdict(Client, iArgs)
{
    new iEnt = GetClientAimTarget(Client, false); 

    if(IsValidEntity(iEnt))
    {
        RemoveEdict(iEnt);
    }
    return Plugin_Handled;
}